#include <iostream>
#include <pthread.h>
#include <stdio.h>

void cleanup(void *)
{
	std::cerr << __FUNCTION__ << std::endl;
}

extern "C"
void bar()
{
#if 1
	try {
		std::cerr << __FUNCTION__ << std::endl;
	} catch (...) {
		std::cerr << __FUNCTION__ << ": caught an exception";
	}
#else
	pthread_key_t k;
	if (pthread_key_create(&k, cleanup) < 0) {
		perror("pthread_key_create");
		return;
	}
	if (pthread_setspecific(k, cleanup) < 0) {
		perror("pthread_setspecific");
		return;
	}
#endif
}
